{
  Another simple component!
  BLINKING LABEL.

  After I read the Nov. issue of Delphi Informant magazine
  about how to make a label blinking by David Rippy,
  then I was inspired to make it a component.
  I tested this component for Delphi 1.0 and Delphi 2.0
  without any problem.

  The purpose of this example is not to make a smart
  or complicated component, Just how to make a simple component.
  >>Using this method you can make any component blinking
  >>If it has got visible property. Blinking Label is just an example.
  I hope you like it.
  Use at your own risk
  Any comments (silly or serious) wellcome.

  Compuserv: 100355,1066
  Internet address: scm@att.net.au
  Yusuf Celik
}
unit BlinkLbl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TBlinkLabel = class(TLabel)
  private
    FBlink :Boolean;         { Make the label blink or not }
    FBlinkInterval :Word;    { Time interval for blinking }
    FTimer :TTimer;          { Standard timer component }
    FOnBlink :TNotifyEvent;  { User defined event }
    procedure SetInterval(Value : Word);
    procedure SetBlink(Value : Boolean);
  protected
    procedure TimerFired(Sender :TObject);dynamic; { Timer event }
    procedure BlinkEvent;dynamic;                       { user defined timer event }
  public
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
  published
    property Blink : Boolean
             read FBlink
             write SetBlink default False;
    property BlinkInterval : Word
             read FBlinkInterval
             write SetInterval default 500;
    property Transparent default True;
    { User defined event }
    property OnBlink: TNotifyEvent read FOnBlink write FOnBlink;

  end;

procedure Register;

implementation

constructor TBLinkLabel.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);

  FBlinkInterval := 500;
  FBlink := False;
  { I don't like default label fonts }
  { That's why I decided to use the fonts I like }
  Font.Height := -11;
  Font.Name := 'MS Sans Serif';
  Font.Size := 8;
  Font.Style:= [fsBold];
  Transparent := True; { Make the label transparent }

  FTimer := TTimer.Create(Self);
  FTimer.OnTimer := TimerFired;
  FTimer.Enabled := False;
  FTimer.Interval := 500;
end;

procedure TBLinkLabel.SetInterval(Value:Word);
begin
  if FBlinkInterval <> Value then
  begin
     FBlinkInterval  := Value;
     FTimer.Interval := Value;
  end;
end;

procedure TBLinkLabel.SetBlink(Value:Boolean);
begin
  if FBlink <> Value then
  begin
     FBlink         := Value;
     FTimer.Enabled := Value;
  end;
 { Prevent label from being invisible
   When the blink becomes off }
  if not FTimer.Enabled then
     Visible := True
end;

procedure TBLinkLabel.TimerFired(Sender :TObject);
begin
  BlinkEvent; { Fir up user defined event }
  visible := not visible;
end;

{ User defined event that will be called }
procedure TBLinkLabel.BlinkEvent;
begin
  if Assigned(FOnBlink) then
     FOnBlink(Self);
end;

destructor TBLinkLabel.Destroy;
begin
  FTimer.free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Yusas', [TBlinkLabel]);
end;

end.

